{***************************************************
  2005.08.18 v0.6
  2004.05.22 v0.5
  2004.01.18 v0.4
  2004.01.08 v0.3
  2003.07.06 port to FreePascal 1.0.6 (go32v2/Win32)
****************************************************}
program CheckNt;
Uses plType, plFile, plStr, SysUtils, plMem;
{== । ⨯  ⠭ ==}
{$I type.inc}
const log1 = 'ChkNtHdr.log';
      log2 = 'ChkNtBlk.log';
      log3 = 'ChkNtLnk.log';
{=================================================== Var ===}
var F,fs,L,L1:longint;
    FMode:Byte;
    c:char;
    i:integer;
    s:string;
    OldAttr:Word;
    Head:NTHeader;
    b:boolean;
    log:text;

    Err_LinksTotal,ver:longint;
    Err_RootKeyOffs,
    lf_exists,
    lh_exists,
    db_exists:boolean;

    pLK:PLostKey;
    //pLP:PLostParent;

    blockMaxSize,blockMinSize,blockMaxFree,
    blockTotalFree,blockTotalUsed:longint;

    autoFix:boolean;
{=================================================== Var ===}
{== ⥫ 楤==}
{$I rebuild.inc}
{$I CheckNt.inc}
{$I links.inc}
begin
     Writeln('Registry Checker 0.6 for WinNT/2K/XP by General Paul Lee (c) 2003-2005.');
     If ParamCount<1 Then Begin
        Writeln;
        Writeln('This program is for checking WinNT/2K/XP registry files in DOS mode');
        Writeln('and simple bugfixing.');
        Writeln;
        Writeln('Usage: CheckNt <regfile> [-a]');
        Writeln;
        Writeln('       -a   auto fix');
        Exit;
     End;
     FMode:=fmOpenReadWrite;
     OldAttr:=0;
     F:=FileOpen(ParamStr(1),FMode);
     If F=-1 Then begin
      OldAttr:=FileGetAttr(ParamStr(1));
      If FileSetAttr(ParamStr(1),0)<>-1 Then
           F:=FileOpen(ParamStr(1),FMode)
      else OldAttr:=0;
     end;
     If F=-1 Then Begin
        FMode:=fmOpenRead;
        F:=FileOpen(ParamStr(1),FMode);
     End;
     autoFix:=ParamStr(2)='-a';
     assign(log,log1);
     rewrite(log);
     writeln(log,ParamStr(1));
     s:='=[header]';s:=s+'='*(79-byte(s[0]));
     writeln(log,s); writeln(s);
     If F=-1 Then Begin
        s:='File open error.';
        Writeln(log,s); Writeln(s);
        Exit;
     End;
     fs:=FileSize(F);
     if fs<8192 Then Begin
        s:='File is empty or corrupt.';
        Writeln(log,s); Writeln(s);
        FileClose(F);
        Exit;
     End;
     FileRead(F,Head,SizeOf(NTHeader));
     if(Head.Head<>h_regf)and(SearchNextHbin(F,$1000,fs)=-1) Then Begin
        s:='File is corrupt or not in WinNT/2K/XP registry format.';
        Writeln(log,s); Writeln(s);
        FileClose(F);
        Exit;
     End;
     if(Head.DataSize+$1000)>fs Then Begin
        s:='File is broken. File size must be not less '+HexStr(Head.DataSize+$1000,4)+'h bytes.';
        Writeln(log,s); Writeln(s);
        b:=false;
        if FMode=fmOpenReadWrite then begin
           if(Head.DataSize>$80000000)or(Head.DataSize<$2000)then s:=''
           else s:='Enlarge file [E] or ';
           s:='Patch info about data size [Y/N]:';
           write(log,s);
           c:=Ask(s);
           writeln(log,c);
           if((Head.DataSize>$80000000)or(Head.DataSize<$2000))and(c<>'y')then
            c:='n';
           case c of
           'e': if(FileSeek(F,Head.DataSize+$1000-1,fsFromBeginning)<>-1)
                and(FileWrite(F,0,1)<>-1)then begin
                 b:=true;
                 fs:=FileSize(F);
                end;
           'y': begin
                     Head.DataSize:=fs-$1000;
                     Head.CheckSum:=CheckSum(@Head,(SizeOf(Head)-1)shr 2);
                     if(FileSeek(F,0,fsFromBeginning)<>-1)
                     and(FileWrite(F,Head,SizeOf(Head))<>-1)then begin
                      b:=true;
                      write(log,' Updated.');
                     end;
                end;
           end; {case}
        end;
        if not b then begin
           FileClose(F);
           Exit;
        end;
     End;
     L:=GetDataSize(F,fs);
     if(Head.DataSize<L)then begin
        s:='DataSize is wrong ('+HexStr(Head.DataSize,4)+'h).';
        Write(log,s); Write(s);
        b:=false;
        if FMode=fmOpenReadWrite then begin
           c:=Ask(' Update?[Y/N]:');
           if c='y' then begin
            Head.DataSize:=L;
            Head.CheckSum:=CheckSum(@Head,(SizeOf(Head)-1)shr 2);
            if(FileSeek(F,0,fsFromBeginning)<>-1)
            and(FileWrite(F,Head,SizeOf(Head))<>-1)then begin
             b:=true;
             write(log,' Updated.');
            end;
           end;
        end;
        writeln(log);
        if not b then begin
           FileClose(F);
           Exit;
        end;

     end;
     pLK:=nil;
     //pLP:=nil;
     Err_LinksTotal:=0;
     PrintHead(Head);
     s:='=[subheaders]';s:=s+'='*(79-byte(s[0]));
     writeln(log,s); writeln(s);
     if not CheckHbinRelation(F,$1000,Head.DataSize+$1000) then begin
        s:='subheaders relation is wrong';
        writeln(log,s); writeln(s);
     end else begin
        Close(log);
        assign(log,log2);
        rewrite(log);
        writeln(log,ParamStr(1));
        s:='=[datablocks]';s:=s+'='*(79-byte(s[0]));
        writeln(log,s); writeln(s);
        blockMaxSize:=0;blockMinSize:=Head.DataSize;
        blockMaxFree:=0;blockTotalFree:=0;blockTotalUsed:=0;
        b:=CheckDataBlock(F,$1000,Head.DataSize+$1000);
        if b=true then begin
        {----------------------}
           ver:=3;
           if(db_exists)then ver:=4;
           if(lh_exists)then ver:=5;
           if Head.RegVer<>ver then begin
            write(log,'Error: version must be '+LTrim(HexStr(ver,1),'0',1));
            if FMode=fmOpenReadWrite then begin
             c:=Ask('Error: version must be '+LTrim(HexStr(ver,1),'0',1)+'. Update?[Y/N]:');
             if c='y' then begin
              Head.RegVer:=ver;
              Head.Checksum:=CheckSum(@Head,(SizeOf(Head)shr 2)-1);
              if(FileSeek(F,0,fsFromBeginning)=-1)
               or(FileWrite(F,Head,SizeOf(Head))=-1)then begin
               write(log,' Error: update filed!');
               writeln('Error: update filed!');
              end else write(log,' Updated.');
             end;
            end;
            writeln(log);
           end;
           writeln(log,'MaxSize   '+HexStr(blockMaxSize,4)+'h');
           writeln(log,'MinSize   '+HexStr(blockMinSize,4)+'h');
           writeln(log,'MaxFree   '+HexStr(blockMaxFree,4)+'h');
           writeln(log,'TotalFree '+HexStr(blockTotalFree,4)+'h');
           writeln(log,'TotalUsed '+HexStr(blockTotalUsed,4)+'h');
           if not Err_RootKeyOffs then
           writeln(log,'*** WARNING *** Root key was not found.');
        {----------------------}
           Close(log);
           assign(log,log3);
           rewrite(log);
           writeln(log,ParamStr(1));
           s:='=[links]';s:=s+'='*(79-byte(s[0]));
           writeln(log,s); writeln(s);
           CheckLinks(F,$1000,Head.DataSize+$1000);
           writeln('Total errors in "links" section: ',Err_LinksTotal);
           CheckLostKeySize;
           PrintLostKey;
           //PrintLostParent;
           writeln('See '+log3);
        end;
        writeln('See '+log2);
     end;
     writeln('See '+log1);
     FileClose(F);
     Close(log);
     FreeLostKey;
     //FreeLostParent;
     if not Err_RootKeyOffs then writeln('*** WARNING *** Root key was not found.');
     if OldAttr<>0 then FileSetAttr(ParamStr(1),OldAttr);
end.
