{==}
function min(L1,L2:longint):longint;
begin
 if L1<L2 then result:=L1 else result:=L2
end;
{==}
function max(L1,L2:longint):longint;
begin
 if L1>L2 then result:=L1 else result:=L2
end;
{==}
function Ask(s:string):char;
begin
 write(s);
 if autoFix then begin
  result:='y';
  writeln('y');
 end else begin
  readln(result);
  result:=char(byte(result) or $20);
 end;
end;
{==}
function SearchNextBlock(F:longint;LMax,L:longint):longint;
var L1,L2:longint;
begin
     inc(L,4);
     while L<LMax do begin
       FileSeek(F,L,fsFromBeginning);
       FileRead(F,L1,4);
       if(L1<-4)and(L1 and 3=0)and(abs(L1)<=LMax-L)and(abs(L1)>0)then begin
          FileSeek(F,L+abs(L1),fsFromBeginning);
          FileRead(F,L2,4);
          if(L2 and 3=0)and((L2<-4)or(L2>3))and(abs(L2)>0)
           and(abs(L2)<=LMax-L-abs(L1))then break;
       end;
       inc(L,4);
     end;
     SearchNextBlock:=L;
end;
{==}
function SearchPrevBlock(F:longint;LMax,L:longint):longint;
var L1,L2,M:longint;
begin
     L1:=LMax-4;
     M:=LMax;
     While L1>L Do Begin
       FileSeek(F,L1,fsFromBeginning);
       FileRead(F,L2,4);
       if (Abs(L2)=LMax-L1)or(Abs(L2)=M-L1) then begin
        if L2<1 then LMax:=L1;
        M:=L1;
       end;
       dec(L1,4);
     End;
     if M<LMax then LMax:=M;
     SearchPrevBlock:=LMax;
end;
{==}
function CheckSum(p:pointer;count:longint):LongInt;
var L:LongInt;
    i:integer;
begin
     L:=0;
     for i:=1 to count do begin
       L:=(L xor longint(p^));
       inc(pbyte(p),4)
     end;
     CheckSum:=L;
end;
{==}
procedure PrintHead(var Head:NTHeader);
var c:char;
    b:boolean;
    L:longint;
begin
     b:=false;
     write(log,' signature      - ');
     if Head.Head=h_regf then writeln(log,'correct') else begin
      write(log,'wrong');
      if FMode=fmOpenReadWrite then begin
       c:=Ask('Error. Signature not equal "regf". Update?[Y/N]:');
       if c='y' then begin
        Head.Head:=h_regf;
        write(log,' Updated.');
        b:=true;
       end;
      end;
      writeln(log);
     end;
     write(log,' version        - ',Head.RegVer,' (');
     case Head.RegVer of
      cRegNT: write(log,'NT/2K/XP');
      cReg2K: write(log,'--/2K/XP');
      cRegXP: write(log,'--/--/XP');
     else write(log,'unknown '+HexStr(Head.RegVer,4)+'h');
     end; {case}
     writeln(log,')');
     write(log,' rootkey offset - '+HexStr(Head.Offs,4)+'h (',Head.Offs,')');
     Err_RootKeyOffs:=false;
     if(Head.offs<$20)or(Head.offs>Head.DataSize-$50)then begin
      write(log,' is wrong (out of range).');
      writeln('Error. Offset to root key is out of range');
     end else begin
      if(FileSeek(F,Head.offs+$1000,fsFromBeginning)<>-1)
       and(FileRead(F,L,4)<>-1)then begin
       if(L>-$50)then begin
        write(log,' is wrong. ('+HexStr(Head.offs+$1000,4)+': '+HexStr(L,4)+')');
        writeln('Error. Offset to root key is wrong');
       end else begin
        if(FileRead(F,L,4)<>-1)then begin
         if(L and $0CFFFF)<>($0C0000+$6B6E) then begin
          write(log,' is wrong. ('+HexStr(Head.offs+$1004,4)+': '+HexStr(L,4)+')');
          writeln('Error. Offset to root key is wrong');
         end else Err_RootKeyOffs:=true;
        end;
       end;
      end;
     end;
     writeln(log);
     writeln(log,' data size      - '+HexStr(Head.DataSize,4)+'h (',Head.DataSize,')');
     write(log,' check sum      - ');
     if CheckSum(@Head,SizeOf(Head)shr 2)=0 then writeln(log,'correct') else begin
      write(log,'wrong');
      if FMode=fmOpenReadWrite then begin
       c:=Ask('Error. Checksum is wrong. Recalculate?[Y/N]:');
       if c='y' then begin
        write(log,' recalculated.');
        b:=true;
       end;
      end;
      writeln(log);
     end;
     if(Head.RegVer<3)or(Head.RegVer>5) then begin
      write(log,'Warning: version may be wrong '+HexStr(Head.RegVer,4)+'h');
      if FMode=fmOpenReadWrite then begin
       c:=Ask('Warning: version may be wrong '+HexStr(Head.RegVer,4)+'h. Change to version 3?[Y/N]:');
       if c='y' then begin
        Head.RegVer:=3;
        write(log,' Updated.');
        b:=true;
       end;
      end;
      writeln(log);
     end;
     if Head.Seq1<>Head.Seq2 then begin
      write(log,'Error: Sequence1 <> Sequence2.');
      if FMode=fmOpenReadWrite then begin
       c:=Ask('Error. Fields Seq1 and Seq2 in header must be equal. Update?[Y/N]:');
       if c='y' then begin
        Head.Seq1:=1;
        Head.Seq2:=1;
        write(log,' Updated.');
        b:=true;
       end;
      end;
      writeln(log);
     end;
     if(Head.Seq1<>1)or(Head.Seq2<>1)then begin
      write(log,'Warning: Sequence1 and Sequence2 <> 1.');
      if FMode=fmOpenReadWrite then begin
       c:=Ask('Warning. Fields Seq1 and Seq2 not equal 1. Update?[Y/N]:');
       if c='y' then begin
        Head.Seq1:=1;
        Head.Seq2:=1;
        write(log,' Updated.');
        b:=true;
       end;
      end;
      writeln(log);
     end;
     if(Head.H03<>0)or(Head.H04<>0) then begin
      write(log,'Warning: timestamp is not null.');
      if FMode=fmOpenReadWrite then begin
       c:=Ask('Warning. Timestamp in header must be null. Update?[Y/N]:');
       if c='y' then begin
        Head.H03:=0;
        Head.H04:=0;
        write(log,' Updated.');
        b:=true;
       end;
      end;
      writeln(log);
     end;
     if Head.H05<>1 then begin
      write(log,'Error: H05 <> 1.');
      if FMode=fmOpenReadWrite then begin
       c:=Ask('Error. Fields H05 must be 1. Update?[Y/N]:');
       if c='y' then begin
        Head.H05:=1;
        write(log,' Updated.');
        b:=true;
       end;
      end;
      writeln(log);
     end;
     if Head.H07<>0 then begin
      write(log,'Error: H07 <> 0.');
      if FMode=fmOpenReadWrite then begin
       c:=Ask('Error. Fields H07 must be 0. Update?[Y/N]:');
       if c='y' then begin
        Head.H07:=0;
        write(log,' Updated.');
        b:=true;
       end;
      end;
      writeln(log);
     end;
     if Head.H08<>1 then begin
      write(log,'Warning: H08<>1.');
      if FMode=fmOpenReadWrite then begin
       c:=Ask('Warning. Fields H08 not equal 1. Update?[Y/N]:');
       if c='y' then begin
        Head.H08:=1;
        write(log,' Updated.');
        b:=true;
       end;
      end;
      writeln(log);
     end;
     if(Head.H11<1)or(Head.H11>8)then begin
      write(log,'Error: H11 not between 1 and 8.');
      if FMode=fmOpenReadWrite then begin
       c:=Ask('Error. Fields H11 must be in [1..8]. Update?[Y/N]:');
       if c='y' then begin
        Head.H11:=1;
        write(log,' Updated.');
        b:=true;
       end;
      end;
      writeln(log);
     end;
     if b then begin
      Head.Checksum:=CheckSum(@Head,(SizeOf(Head)shr 2)-1);
      if(FileSeek(F,0,fsFromBeginning)=-1)
       or(FileWrite(F,Head,SizeOf(Head))=-1)then begin
       writeln(log,'Error: update filed!');
       writeln('Error: update filed!');
      end;
     end;
end;
{==}
function SearchNextHbin(F:longint;L,LMax:longint):longint;
var hb1:NTHbin;
begin
     SearchNextHbin:=-1;
     While L<LMax Do Begin
       FileSeek(F,L,fsFromBeginning);
       FileRead(F,hb1,SizeOf(NThbin));
       With hb1 do Begin
         If Head=h_hbin Then Begin
            SearchNextHbin:=L;
            Exit;
         End;
         L:=L+HbinStep;
       End;
     End;
end;
{==}
function GetDataSize(F:longint;LMax:longint):longint;
var L:longint;
begin
     L:=0;
     repeat
      result:=L;
      L:=SearchNextHbin(F,L+$1000,fs);
     until L=-1;
     if result>0 then begin
      FileSeek(F,result+8,fsFromBeginning);
      FileRead(F,L,4);
      result+=L;
      if result>fs then result:=fs;
      result-=$1000;
     end else result:=-1;
end;
{==}
function CheckHbinRelation(F:longint;L,LMax:LongInt):boolean;
var count,LMaxhbin,next,prev:longint;
    hb1,hb2:NTHbin;
    c:char;
    s:string;
    b,all1,all2,all3:boolean;
    i:integer;
    LL:LongInt;
begin
     CheckHbinRelation:=false;
     LMaxhbin:=0;
     count:=0;
     prev:=0;
     all1:=autoFix;
     all2:=autoFix;
     all3:=autoFix;
     While L<LMax Do Begin
       write(#13+HexStr(L,4)+' ');
       FileSeek(F,L,fsFromBeginning);
       write(log,HexStr(L,4)+': ');
       FileRead(F,hb1,SizeOf(NThbin));
       FileRead(F,hb2,SizeOf(NThbin));
       With hb1 do Begin
         If (Head<>h_hbin) Then Begin
            if prev=0 then s:='1-st ' else s:='';
            s:=s+'subheader is corrupt';
            writeln(log,s); writeln(s);
            s:=' '*10+HexStr(@hb1,16,' ',1,0)+'  ';
            for i:=0 to 15 do if(PByte(@hb1+i)^<32)or(PByte(@hb1+i)^>127)
             then s+='.' else s+=char(PByte(@hb1+i)^);
            writeln(log,s); if not all3 then writeln(s);
            s:=' '*10+HexStr(@hb1+16,16,' ',1,0)+'  ';
            for i:=16 to 31 do if(PByte(@hb1+i)^<32)or(PByte(@hb1+i)^>127)
             then s+='.' else s+=char(PByte(@hb1+i)^);
            writeln(log,s); if not all3 then writeln(s);
            s:='-'*75;writeln(log,s); if not all3 then writeln(s);
            s:=' '*10+HexStr(@hb2,16,' ',1,0)+'  ';
            for i:=0 to 15 do if(PByte(@hb2+i)^<32)or(PByte(@hb2+i)^>127)
             then s+='.' else s+=char(PByte(@hb2+i)^);
            writeln(log,s); if not all3 then writeln(s);
            s:=' '*10+HexStr(@hb2+16,16,' ',1,0)+'  ';
            for i:=16 to 31 do if(PByte(@hb2+i)^<32)or(PByte(@hb2+i)^>127)
             then s+='.' else s+=char(PByte(@hb2+i)^);
            writeln(log,s); if not all3 then writeln(s);
            s:=' '*10+'searching next subheader...';
            writeln(log,s); writeln(s);
            next:=SearchNextHbin(F,L,LMax);
            if next=-1 then s:=' '*10+'correct subheader not found.'
            else s:=' '*10+'found correct subheader at '+HexStr(next,4)+'h';
            writeln(log,s); writeln(s);
            LL:=L;
            if prev>0 then L:=prev;
            if next=-1 then next:=LMax-L else next:=next-L;
            FileSeek(F,L,fsFromBeginning);
            FileRead(F,hb1,SizeOf(NThbin));
            b:=false;
            if FMode=fmOpenReadWrite then begin
               if prev=0 then s:=' '*10+'recreate 1-st subheader?[Y/N]:'
               else s:=' '*10+'repare this [R] or patch previous (recomended) subheader?[Y/N/A]:';
               write(log,s);
               if not all3 then c:=Ask(s) else c:='y';
               if c='a' then begin
                all3:=true;
                c:='y';
               end;
               writeln(log,c);
               if(c='y')or(c='r')then begin
                if c='y' then begin
                 write(log,HexStr(L,4)+': ');
                 Size:=next;
                 SizeRes:=next;
                end else begin
                   L:=LL;
                   Head:=$6E696268; {'hbin'};
                   Offs:=LL-$1000;
                   w1:=0;w2:=0;
                   w3:=0;w4:=0;
                   L1:=0;L2:=0;
                   if(SizeRes<=LMax-LL)and(SizeRes>=$1000)and
                    (SizeRes and $0FFFFF000=SizeRes)
                   then Size:=SizeRes else begin
                     Size:=$1000;
                     SizeRes:=$1000;
                   end;
                end;
                if prev=0 then begin
                   Head:=$6E696268; {'hbin'};
                   Offs:=0;
                   w1:=0;w2:=0;
                   w3:=0;w4:=0;
                   L1:=0;L2:=0;
                end;
                if(FileSeek(F,L,fsFromBeginning)<>-1)
                 and(FileWrite(F,hb1,SizeOf(NThbin))<>-1)then b:=true
                else begin
                   s:='Write error.';
                   writeln(log,s); writeln(s);
                end;
               end;
            end;
            if not b then begin
               s:='          you may change size of previous subheader to correct:';
               writeln(log,s); writeln(s);
               s:='           offset   DwordSrc DwordDst';
               writeln(log,s); writeln(s);
               s:='          --------- -------- --------';
               writeln(log,s); writeln(s);
               s:='          '+HexStr(L+8,4)+': '+HexStr(Size,4)+' '+HexStr(next,4);
               writeln(log,s); writeln(s);
               FileClose(F);
               exit;
            end;
         End;
         b:=false;
         s:='Offs: '+HexStr(Offs,4)+'h';
         if Offs<>L-$1000 then s:=s+'(wrong)';
         s:=s+' Size: '+HexStr(Size,4)+'h';
         if(Size<$1000)or(Size>LMax-L)or((Size and $0FFF)<>0) then s:=s+'(wrong)';
         writeln(log,s);
         {-------------------}
         if Offs<>L-$1000 then begin
            if FMode=fmOpenReadWrite then begin
             if not all2 then c:=Ask('SelfOffset is wrong. Update?[Y/N]:')else c:='y';
             if c='y' then begin
              Offs:=L-$1000;
              write(log,' Updated.');
              b:=true;
             end;
            end;
            writeln(log);
         end;
         if((Size<$1000)or(Size>LMax-L)or((Size and $0FFF)<>0))then begin
            s:=s+'subheader is corrupt';
            writeln(log,s); writeln(s);
            s:='          searching next subheader...';
            writeln(log,s); writeln(s);
            next:=SearchNextHbin(F,L,LMax);
            if next=-1 then begin
             s:='          correct subheader not found.';
             next:=LMax;
            end else begin
             s:='          found correct subheader at '+HexStr(next,4)+'h';
             next:=next;
            end;
            dec(next,L);
            writeln(log,s); write(s);
            if FMode=fmOpenReadWrite then begin
             if not all2 then c:=Ask(' Update?[Y/N]:')else c:='y';
             if c='y' then begin
              Size:=next;
              SizeRes:=next;
              write(log,' Updated.');
              b:=true;
             end;
            end;
            writeln(log);
         end;
         {-------------------}
         if Size<>SizeRes then begin
          write(log,' Warning: Size<>Size-reserved.');
          if FMode=fmOpenReadWrite then begin
           if not all1 then c:=Ask('Warning. Fields Size and Size-reserved not equal. Update?[Y/N/A]:')
            else c:='y';
           if c='a' then begin
            all1:=true;
            c:='y';
           end;
           if c='y' then begin
            SizeRes:=Size;
            write(log,' Updated.');
            b:=true;
           end;
          end;
          writeln(log);
         end;
         if(w1<>0)or(w2<>0)or(w3<>0)or(w4<>0)or(L1<>0)or(L2<>0)then begin
          write(log,' Warning: several fields is not 0.');
          if FMode=fmOpenReadWrite then begin
           if not all2 then c:=Ask('Warning: several fields is not 0. Clean?[Y/N/A]:')
            else c:='y';
           if c='a' then begin
            all2:=true;
            c:='y';
           end;
           if c='y' then begin
            w1:=0;w2:=0;
            w3:=0;w4:=0;
            L1:=0; L2:=0;
            write(log,' Updated.');
            b:=true;
           end;
          end;
          writeln(log);
         end;
         if b then if(FileSeek(F,L,fsFromBeginning)=-1)
          or(FileWrite(F,hb1,SizeOf(NThbin))=-1)then begin
           writeln(log,'Error: update filed!');
           writeln('Error: update filed!');
         end;
         prev:=L;
         If LMaxhbin<Size Then LMaxhbin:=Size;
         Inc(count);
         L:=L+Size;
       End;
     End;
     s:='total subheaders: ';
     writeln(log,s,count); writeln(s,count);
     CheckHbinRelation:=true;
     write(#13);
end;
{==}
function CheckDataBlock(F:longint;L,LMax:longint):boolean;
var hb:NThbin;
    L1,L2,L3,LL,i:longint;
    s,s1:string;
    c:char;
    b,all1:boolean;
    w:word;
begin
     b:=true;
     lf_exists:=false;
     lh_exists:=false;
     db_exists:=false;
     all1:=autoFix;
     writeln(log,'---------------------------');
     writeln(log,' Address  Del   Size   Type');
     writeln(log,'--------- --- -------- ----');
     While L<LMax Do Begin
        FileSeek(F,L,fsFromBeginning);
        L1:=L+$20;
        FileRead(F,hb,SizeOf(NThbin));
        // Writeln(log,HexStr(L,4),':     '+HexStr($20,4)+' hbin');
        L:=L+hb.Size;
        While L1<L Do Begin
           write(#13+HexStr(L1,4)+' ');
           s:='  ';
           s1:=HexStr(L1,4)+':  ';
           FileSeek(F,L1,fsFromBeginning);
           FileRead(F,L3,4);
           FileRead(F,s[1],2);
           FileRead(F,w,2);
           If L3<0 Then s1+='   ' Else s1+='*  ';
           L2:=Abs(L3);
           s1+=HexStr(L2,4)+'  '+s;
           case PWord(@s[1])^ of
            {h_lf}$666C:lf_exists:=true;
            {h_lh}$686C:lh_exists:=true;
            {h_db}$6264:db_exists:=true;
           end; {case}
           if (L2<0)or(L2>L-L1)or((L2 and 3)<>0)or((L3>-8)and(L2<4))then begin
              L2:=L-L1;
              writeln(log,s1);
              s:='*** wrong size of block;';
              write(log,s); write(s);
              if FMode=fmOpenReadWrite then begin
                 s:=' patch this?[Y/N/A]:';
                 write(log,s);
                 if not all1 then c:=Ask(s) else begin
                  c:='y';
                  writeln;
                 end;
                 if c='a' then begin
                  all1:=true;
                  c:='y';
                 end;
                 writeln(log,c);
                 if c='y' then begin
{-----------}
                  L3:=Min(SearchPrevBlock(F,L,L1),SearchNextBlock(F,L,L1))-L1;
                  L2:=L3;
{-----------}
                  {LL:=$0FFFFFFFC;}
                  LL:=4;
                  FileSeek(F,L1,fsFromBeginning);
                  FileWrite(F,L3,4);
                  for i:=1 to (L3 shr 2)-1 do FileWrite(F,LL,4);
                 end else begin
                  s:=' jump to next part ***';
                  writeln(log,s); writeln(s);
                  b:=false;
                 end;
              end else b:=false;
           end;
           if(not Err_RootKeyOffs)and(L3<=-$50)
            and(PWord(@s[1])^=$6B6E)and(w and $0C = $0C)then begin
             writeln(log,s1);
             write(log,'Root key found.');
             if FMode=fmOpenReadWrite then begin
              c:=Ask('Warning. Root key found at '+HexStr(L1,4)+'. Update header?[Y/N]:');
              if c='y' then begin
               L3:=L1-$1000;
               if(FileSeek(F,$24,fsFromBeginning)=-1)
                or(FileWrite(F,L3,4)=-1)then begin
                 write(log,' Error: update filed!');
                 writeln('Error: update filed!');
               end else begin
                Err_RootKeyOffs:=true;
                Head.Offs:=L3;
                write(log,' Header was is updated.');
               end;
              end;
             end;
             writeln(log);
           end;
           Inc(L1,L2);
           {---------------------}
           if(L3<0)then begin
            blockMaxSize:=max(blockMaxSize,abs(L3));
            blockMinSize:=min(blockMinSize,abs(L3));
            inc(blockTotalUsed,abs(L3));
           end else begin
            blockMaxFree:=max(blockMaxFree,abs(L3));
            inc(blockTotalFree,L3);
           end;
           {---------------------}
        End;
     End;
     CheckDataBlock:=b;
     write(#13);
end;
{==}
